## Zadanie drugie

Zadanie polega na napisaniu symulatora maszyny stosowej, której stos przechowuje wyrażenia typu `Expression`.

Program na maszynę stosową składa się z tablicy funkcji, a funkcje zawierają swoją nazwę, informację o tym, czy zwracają jakąś wartość, liczbę argumentów oraz tablicę instrukcji.
Argumenty funkcji są przechowywane na stosie (i usuwane przez funkcję wołaną), a wynik jest umieszczany na szczycie stosu.
Przykładowo, jeśli mamy funkcję `f`, która przyjmuje trzy argumenty i zwraca wynik, to wysokość stosu po zakończeniu wykonania tej funkcji powinna się zmniejszyć o 2. 
Funkcja nie może zdejmować ze stosu więcej wartości niż jej liczba argumentów.
Funkcje nie mogą tworzyć rekurencji (nie ma instrukcji warunkowych, więc nie mielibyśmy jak tej rekurencji przerwać).
Przed uruchomieniem programu należy upewnić się, że wszystkie funkcje spełniają powyższe warunki.
Uruchomienie programu zaczyna się od wywołania funkcji `main`, która nie przyjmuje żadnych argumentów i nie zwraca wyniku.

Maszyna obsługuje następujące instrukcje:
* `PushVariable` - umieszcza na stosie wyrażenie typu `Variable`
* `PushConstant n` - umieszcza na stosie wyrażenie typu `Constant(n)`
* `Sine` - zdejmuje wyrażenie `expr` ze stosu i umieszcza `sin(expr)` na stosie 
* `Cosine` - zdejmuje wyrażenie `expr` ze stosu i umieszcza `cos(expr)` na stosie
* `Add` - zdejmuje dwa wyrażenia ze stosu i umieszcza ich sumę w rejestrze na stosie
* `Multiply` - zdejmuje dwa wyrażenia ze stosu i umieszcza ich mnożenie na stosie
* `Derivative` - zdejmuje wyrażenie ze stosu i umieszcza jego pochodną na stosie
* `ValueAt` - zdejmuje wyrażenie `expr1` ze stosu, a następnie zdejmuje wyrażenie `expr2` ze stosu i umieszcza `expr2(expr1(0))` (jako `Constant`) na stosie (czyli liczymy wartość wyrażenia `expr2` w punkcie `expr1(0)`)
* `Integrate` - zdejmuje wyrażenia `expr1`, `expr2`, `expr3` i `expr4` ze stosu i umieszcza całkę oznaczoną (jako `Constant`) wyrażenia `expr4` od `expr3(0)` do `expr2(0)` z dokładnością `(int) expr4(0)` na stosie
* `Duplicate` - duplikuje wyrażenie ze szczycie stosu
* `Swap` - zamienia miejscami dwa wyrażenia na szczycie stosu
* `Pop` - zdejmuje wyrażenie ze stosu i je porzuca
* `Print` - wypisuje na standardowe wyjście wyrażenie ze szczycie stosu
* `Function name` - wywołuje funkcję o nazwie `name`

Proszę nie robić wczytywania programów z pliku/standardowego wejścia, wystarczy że będzie się dało stworzyć program odpowiednimi konstruktorami. Zależy mi na:
* czytelności kodu
* nacisku na obiektowość
* jednym teście `JUnit` programu składającego się z 2-3 funkcji.

Jako stos można użyć kodu, który pisaliśmy na zajęciach (wystarczy podmienić typ wartości na `Expression`).

Przykładowy program:
```
Function g (2 args, returns value):
    Add

Function main (0 args, doesn't return value):
    PushConstant 1.0
    PushConstant 2.0
    Function g
    PushConstant 3.0
    Multiply
    PushConstant 4.0
    Function g
    Print  // 13.0
    PushVariable
    PushVariable
    Multiply
    Function g
    Function f
    
Function f (1 arg, doesn't return value):
    Print  // x * x + 13.0
    Derivative
    Print  // 2.0 * x
    Derivative
    Print  // 2.0
    Derivative
    Print  // 0.0
    Pop
```
