
import machine.*;
import machine.instructions.*;

public class Main {

    public static void main(String[] args) {
        Program program = new Program(new FunctionDefinition[]{
                new FunctionDefinition("g", true, 2, new Instruction[]{
                        new Add()
                }),
                new FunctionDefinition("main", false, 0, new Instruction[]{
                        new PushConstant(1),
                        new PushConstant(2),
                        new FunctionInvocation("g", true, 2),
                        new PushConstant(3),
                        new Multiply(),
                        new PushConstant(4),
                        new FunctionInvocation("g", true, 2),
                        new Print(),
                        new PushVariable(),
                        new PushVariable(),
                        new Multiply(),
                        new FunctionInvocation("g", true, 2),
                        new FunctionInvocation("f", false, 1)
                }),
                new FunctionDefinition("f", false, 1, new Instruction[]{
                        new Print(),
                        new Derivative(),
                        new Print(),
                        new Derivative(),
                        new Print(),
                        new Derivative(),
                        new Print(),
                        new Pop()
                })
        });
        ProgramExecutor programExecutor = new ProgramExecutor(program);
        if (!program.validate())
            System.out.println("Program is invalid");
        else
            programExecutor.execute();
    }
}
