package expr;

public class Add extends Operator {

    protected Add(Expression left, Expression right) {
        super(left, right);
    }

    @Override
    public double valueAt(double x) {
        return left.valueAt(x) + right.valueAt(x);
    }

    @Override
    public Expression derivative() {
        return left.derivative().add(right.derivative());
    }

    @Override
    protected int getWeight() {
        return 100;
    }

    @Override
    protected String getSymbol() {
        return "+";
    }
}
