package expr;

public class Constant extends Expression {

    private final double value;

    protected Constant(double value) {
        this.value = value;
    }

    public static Constant create(double value) {
        if (value == 0.) {
            return ZeroConstant.instance;
        }
        if (value == 1.) {
            return OneConstant.instance;
        }
        return new Constant(value);
    }

    @Override
    public double valueAt(double x) {
        return value;
    }

    @Override
    public Expression derivative() {
        return ZeroConstant.instance;
    }

    @Override
    public String asString() {
        if (value < 0) {
            return "(" + value + ")";
        }
//        return Double.toString(value);
        return "" + value;
    }
}
