package expr;

public class Cosine extends Function {

    public Cosine(Expression argument) {
        super(argument);
    }

    @Override
    public double valueAt(double x) {
        return Math.cos(argument.valueAt(x));
    }

    @Override
    public Expression derivative() {
        return Constant.create(-1.0).multiply(
                (new Sine(argument)).multiply(
                        argument.derivative()
                )
        );
    }

    @Override
    protected String getName() {
        return "cos";
    }
}
