package expr;

public class Multiply extends Operator {

    protected Multiply(Expression left, Expression right) {
        super(left, right);
    }

    @Override
    public double valueAt(double x) {
        return left.valueAt(x) * right.valueAt(x);
    }

    @Override
    public Expression derivative() {
        return left.derivative().multiply(right).add(left.multiply(right.derivative()));
    }

    @Override
    protected int getWeight() {
        return 1000;
    }

    @Override
    protected String getSymbol() {
        return "*";
    }
}
