package expr;

public class Sine extends Function {

    public Sine(Expression argument) {
        super(argument);
    }

    @Override
    public double valueAt(double x) {
        return Math.sin(argument.valueAt(x));
    }

    @Override
    public Expression derivative() {
        return (new Cosine(argument)).multiply(argument.derivative());
    }

    @Override
    protected String getName() {
        return "sin";
    }
}
