package machine;

import expr.Expression;

public class ExpressionStack {
    private final Expression[] stack;
    private int top;

    public ExpressionStack() {
        stack = new Expression[10];
        top = -1;
    }

    public void push(Expression e) {
        if (top == stack.length - 1) {
            resize();
        }
        stack[++top] = e;
    }

    public Expression pop() {
        if (top == -1) {
            return null;
        }
        return stack[top--];
    }

    public Expression peek() {
        if (top == -1) {
            return null;
        }
        return stack[top];
    }

    private void resize() {
        System.arraycopy(stack, 0, stack, 0, stack.length * 2);
    }
}
