package machine;

import expr.Expression;

public class ProgramExecutionState {

    private final ExpressionStack stack = new ExpressionStack();

    private final Program program;

    public ProgramExecutionState(Program program) {
        this.program = program;
    }


    public void push(Expression e) {
        stack.push(e);
    }

    public Expression pop() {
        return stack.pop();
    }

    public Expression peek() {
        return stack.peek();
    }

    public FunctionDefinition getFunction(String name) {
        return program.getFunction(name);
    }
}
