package machine;

import expr.Expression;

public class ProgramExecutor {

    private final ProgramExecutionState programExecutionState;

    public ProgramExecutor(Program program) {
        programExecutionState = new ProgramExecutionState(program);
    }

    public void execute() {
        programExecutionState.getFunction("main").execute(programExecutionState);
    }

    // package visibility for testing
    void executeFunction(String name) {
        programExecutionState.getFunction(name).execute(programExecutionState);
    }

    // package visibility for testing
    Expression pop() {
        return programExecutionState.pop();
    }
}
