package machine.instructions;

import expr.Constant;
import expr.Expression;
import machine.ProgramExecutionState;

public class Integral implements Instruction {

    @Override
    public void execute(ProgramExecutionState programExecutionState) {
        Expression expr1 = programExecutionState.pop();
        Expression expr2 = programExecutionState.pop();
        Expression expr3 = programExecutionState.pop();
        Expression expr4 = programExecutionState.pop();
        programExecutionState.push(Constant.create(expr4.integral(expr3.valueAt(0.0), expr2.valueAt(0.0), (int) expr1.valueAt(0.0))));
    }

    @Override
    public int getStackPops() {
        return 4;
    }

    @Override
    public int getStackPushes() {
        return 1;
    }
}
