package machine.instructions;

import expr.Constant;
import machine.ProgramExecutionState;

public class PushConstant implements Instruction {

    private final double value;

    public PushConstant(double value) {
        this.value = value;
    }

    @Override
    public void execute(ProgramExecutionState programExecutionState) {
        programExecutionState.push(Constant.create(value));
    }

    @Override
    public int getStackPops() {
        return 0;
    }

    @Override
    public int getStackPushes() {
        return 1;
    }
}
