package machine.instructions;

import expr.Expression;
import machine.ProgramExecutionState;

public class Swap implements Instruction {

    @Override
    public void execute(ProgramExecutionState programExecutionState) {
        Expression temp1 = programExecutionState.pop();
        Expression temp2 = programExecutionState.pop();
        programExecutionState.push(temp1);
        programExecutionState.push(temp2);
    }

    @Override
    public int getStackPops() {
        return 2;
    }

    @Override
    public int getStackPushes() {
        return 2;
    }
}
