package machine.instructions;

import expr.Constant;
import expr.Expression;
import machine.ProgramExecutionState;

public class ValueAt implements Instruction {

    @Override
    public void execute(ProgramExecutionState programExecutionState) {
        Expression expr1 = programExecutionState.pop();
        Expression expr2 = programExecutionState.pop();
        programExecutionState.push(Constant.create(expr2.valueAt(expr1.valueAt(0.0))));
    }

    @Override
    public int getStackPops() {
        return 2;
    }

    @Override
    public int getStackPushes() {
        return 1;
    }
}
