package machine;

import expr.Expression;
import machine.instructions.*;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class ProgramExecutorTest {

    @Test
    public void test() {
        Program program = new Program(new FunctionDefinition[]{
                new FunctionDefinition("main", false, 0, new Instruction[]{
                        new FunctionInvocation("begin_function", true, 0),
                        new Pop()
                }),
                new FunctionDefinition("begin_function", true, 0, new Instruction[]{
                        new PushConstant(1),
                        new PushConstant(2),
                        new FunctionInvocation("g", true, 2),
                        new PushConstant(3),
                        new Multiply(),
                        new PushConstant(4),
                        new FunctionInvocation("g", true, 2)
                }),
                new FunctionDefinition("g", true, 2, new Instruction[]{
                        new Add()
                })
        });
        ProgramExecutor programExecutor = new ProgramExecutor(program);
        assertTrue(program.validate());
        programExecutor.executeFunction("begin_function");
        Expression expression = programExecutor.pop();
        assertEquals(13, expression.valueAt(0));
    }
}